Program Integrali;



{---------------------------------------------------------------------------}
Type Funkcija=Function (X: real): real;
Var h: real;
    N: longint;

{$F+}
{---------------------------------------------------------------------------}
Function TaisnsturuMet(F: Funkcija; a,b: real): real;
Var s: real;
    k: longint;
Begin
     s:=0;
     for k:=0 to N-1 do s:=s+F(a+k*h);
     TaisnsturuMet:=h*s
End;
Function F1(x: real): real;
Begin
     F1:=(sqrt(x*x*x*x*x*x*x)-sqrt(x*x*x*x*x))/(1-x)
End;

{---------------------------------------------------------------------------}
Function F2(x: real): real;
Begin
     F2:=(x*x*x*x*arctan(x))/(1+x*x)
End;
{$F-}
{---------------------------------------------------------------------------}

Function TrapecuMet(F: Funkcija; a,b: real): real;
Var s: real;
    k: longint;
Begin
     s:=0;
     for k:=1 to N-1 do s:=s+F(a+k*h);
     s:=s*2+F(a)+F(b);
     TrapecuMet:=s*h/2
End;

{---------------------------------------------------------------------------}
Function SimpsonaMet(F: Funkcija; a,b: real): real;
Var s1,s: real;
    k: longint;
Begin
     s:=0;
     s1:=0;

     k:=1;
     while k<=N-1 do begin
                     s1:=s1+F(a+k*h);
                     k:=k+2
                     end;
     s:=s+s1*4;

     k:=2;
     s1:=0;
     while k<=N-1 do begin
                     s1:=s1+F(a+k*h);
                     k:=k+2
                     end;
     s:=s+s1*2;

     s:=s+F(a)+F(b);
     SimpsonaMet:=s*h/3
End;

{---------------------------------------------------------------------------}
Procedure Rezultati(F: Funkcija; a,b: real);
Var j: byte;
Begin
     N:=1;
     For j:=0 to 6 do begin
         h:=(b-a)/N;
         Writeln(j,'  ',
                 TaisnsturuMet(F,a,b):5:5,'   ',
                 TrapecuMet(F,a,b):5:5,'   ',
                 SimpsonaMet(F,a,b):5:5);
         N:=N*10
                      end;
     Writeln
End;

BEGIN
     Rezultati(F1, Pi/8, Pi/4);
     Rezultati(F2, 0, Pi)
END.
